$title "N900 Fast GPS Fix"
$tags N900 GPS

If anyone is, like me, still using the N900, they may have noticed that
acquiring an initial GPS fix can take minutes. The reason for this is that even
in the latest CSSU, supl.nokia.com no longer works as a location server. The fix
for this is actually relatively quick and easy and will make an initial GPS fix
take seconds rather than minutes.

$pre

The exact details of what needs to be done can be found in the last few posts of
[this][tmo-thread] Maemo forum thread. The problem is that supl.nokia.com no
longer resolves to an IP address. However, this doesn't mean that the server
behind supl.nokia.com is no longer running. Surprisingly, it still is.

The long and short of it is this:

1. Make sure you have the latest CSSU and a working N900 to begin with;
2. Go [here][certman] and download `libmaemosec-certman0_0.2.10_armel.deb`,
   `libmaemosec0_0.2.10_armel.deb`, `maemosec-certman-common-ca_0.2.10_all.deb`,
   and `maemosec-certman-tools_0.2.10_armel.deb`;
3. Install the above packages via the command line as root (you'll need gainroot)
   by using `dpkg -i` (put all the files in their own directory and use `dpkg -i
   *` to save time);
4. Edit `/etc/hosts` and change `supl.nokia.com` to point to `52.200.182.188`;
5. Check it all works by running `cmcli -T common-ca -v supl.nokia.com:7275` and
   `cmcli -T location-proxy -v supl.nokia.com:7275`, both should say "Verified
   OK.";
6. If this doesn't work, try `stop location-proxy` and then
   `start location-proxy` (as root) and go back to step 5.

GPS fixes should happen very quickly now. If it's the year 2023 and this didn't
work then good luck finding a new fix, hopefully you put the details on your
blog too. Alternatively, feel free to contact me and I might still be using the
N900 and might know how to help.

[tmo-thread]: https://talk.maemo.org/showthread.php?t=90651
[certman]:    http://maemo.merlin1991.at/cssu/community-devel/pool/free/m/maemo-security-certman
